﻿using System;

namespace grabn
{
    class Program
    {
        static void sample()
        {
            const UInt32 FRAME_COUNT = 20;

            using (Euresys.GenTL genTL = new Euresys.GenTL())
            {
                using (Euresys.RGBConverter.RGBConverter converter = new Euresys.RGBConverter.RGBConverter(genTL))
                {
                    using (Euresys.EGrabberCallbackOnDemand grabber = new Euresys.EGrabberCallbackOnDemand(genTL))
                    {
                        grabber.runScript("./config.js");
                        grabber.reallocBuffers(FRAME_COUNT);

                        grabber.start(FRAME_COUNT);
                        for (uint frame = 0; frame < FRAME_COUNT; ++frame)
                        {
                            using (Euresys.ScopedBuffer buffer = new Euresys.ScopedBuffer(grabber))
                            {
                                Euresys.SizeT size;
                                UInt64 timestamp;
                                IntPtr imgPtr;
                                Euresys.SizeT width;
                                Euresys.SizeT height;
                                UInt64 format;

                                buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_SIZE_FILLED, out size);
                                buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_TIMESTAMP, out timestamp);
                                buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_BASE, out imgPtr);

                                buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_WIDTH, out width);
                                buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_DELIVERED_IMAGEHEIGHT, out height);
                                buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_PIXELFORMAT, out format);

                                System.Console.WriteLine("Acquisition Index: {0}", frame);
                                System.Console.WriteLine(" - Width: {0}", width);
                                System.Console.WriteLine(" - Height: {0}", height);
                                System.Console.WriteLine(" - Size: {0}", size);
                                System.Console.WriteLine(" - Timestamp: {0}.{1}", timestamp / 1000000, /*std::setw(6) << std::setfill('0')*/ timestamp % 1000000);

                                using (Euresys.RGBConverter.BGR8 conv = new Euresys.RGBConverter.BGR8(converter, imgPtr, format, width, height))
                                {
                                    // Converted buffer available from conv.getBuffer()
                                    conv.saveToDisk("frame.NNN.jpeg", frame);
                                }
                            }
                        }
                    }
                }
            }
        }

        static void Main(string[] args)
        {
            try
            {
                sample();
            }
            catch (System.Exception e)
            {
                System.Console.WriteLine(e.Message);
            }
        }
    }
}
